#include <iostream>
#include <string>
#include <fstream>
#include <Windows.h>
#include "Picture.h"
#include <vector>
#include <list>
#include <stack> // LIFO
#include <queue> // FIFO

using namespace std;

void saveFile(Picture& picture);

void main()
{
	//STL - standard Template Library

	//mold / machine for cookie cutters  - template
	//cookie cutter - Class/Struct
	//cookie - object
	vector<int> myInts;
	vector<float> myFloats;

	for (int i = 0; i < 500;i++)
	{
		myInts.push_back(i);
	}

	//vector direct access
	//add/remove to the end
	cout << myInts.size() << endl;
	myInts.pop_back();
	cout << myInts.size() << endl;
	cout << myInts[3] << endl;

	//iterator
	//vector<int>::iterator it = myInts.begin();
	//cout << *it << endl;
	//it++;
	//cout << *it << endl;

	for (auto it = myInts.begin();
			it != myInts.end(); it++)
	{
		cout << *it << endl;
	}

	for (auto it = myInts.rbegin();
	it != myInts.rend(); it++)
	{
		cout << *it << endl;
	}

	list<int> myIntList;
	myIntList.push_front(1);
	myIntList.push_back(2);

	vector<vector<int>> stuff;
	for (int i = 0; i < 10; i++)
	{
		vector<int> l;
		for (int j = 0; j < i + 1; j++)
		{
			l.push_back(j);
		}
		stuff.push_back(l);
	}

	stack<int> myStack;

	for (int i = 0; i < 50;i++)
	{
		myStack.push(i);
	}
	for (int i = 0; i < 50;i++)
	{
		cout << myStack.top() << endl;
		myStack.pop();
	}

}
